package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.jinLiquor.Jin20009ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.Jin20009ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.JinDealerBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Jin20009ReqDealerInfo extends ProtBase {

	private final short iTaskCode20009 = 20009;
	private Gson gson;
	private Jin20009ResBean resBean;
	private List<JinDealerBean> dealerList = new ArrayList<>();
	private boolean isEnd = false;//true：所有协议包已经请求完      false：服务器返回的数据还未接收完全

	public Jin20009ReqDealerInfo() {
		// this.sInspectorId = sInspectorId;
		gson = new Gson();
	}

	public Jin20009ResBean getResBean() {
		return this.resBean;
	}

	public void reqDealerInfo(SocketCreate create, Jin20009ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(),reqBean);
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis,Jin20009ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode20009, "开始请求经销商列表");
				sendProt(dos,reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				while (!isEnd) {
					//服务器可能分多次包返回数据
					recLoginDis(dis);
				}
			}
		}
	}

//	static int cTest = 0;

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
//		debugLog(iTaskCode20009, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20009, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Jin20009ResBean.class);
			
			if (resBean.getList() != null) {
				dealerList.addAll(resBean.getList());
			}
			if (resBean.getIndex() == 0) {
				//所有协议包已经请求完
				resBean.setList(dealerList);
				isEnd = true;
			}
			if (resBean.getResult() == 1) {
				//请求时遇到错误信息
				isEnd = true;
			}
		} else {
			isEnd = true;
		}

		recCheckCode(dis);
		
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos,Jin20009ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
//		String bodyContent = "{}";
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20009, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
